#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
# DPD (Dummy Plagiarism Detector) v.0.1
# by Amos Brocco <amos.brocco@unifr.ch>
# 15 Feb 2007, GNU GPL License
# Requires: wget, pdftotext (only for pdf support) and GNU recode 
# + Internet connection (uses google web search :) )
import os
from string import *
from commands import *
import re
import time
import sys

MIN_WORDS = 7
MAX_WORDS = 20
phraseSeparators = [".",";"]
invalidChars = ["","\r","\n","\t","−","-","+","\"",",",":"," the "," a "," an "," A "," An "]
tempoutput = ""

if len(sys.argv) < 2:
	print "Usage:",sys.argv[0],"inputfile [minwords] [maxwords]"
	sys.exit(0)
if len(sys.argv) >= 3:
	MIN_WORDS = int(sys.argv[2])
if len(sys.argv) > 3:
	MAX_WORDS = int(sys.argv[3])
inputfile = sys.argv[1]
ftype = getoutput("file -ib %s" % (inputfile))
if ftype.find("application/pdf") != -1:
	print "Input file is a PDF, converting it to plain text...",
	tempoutput = inputfile+".txt"
	getoutput("pdftotext %s %s" % (inputfile, tempoutput))
	print "done"
	inputfile = tempoutput
elif ftype.find("text/plain") != -1:
	print "Input file is a text file, ok!"
else:
	print "Unknown file type:",ftype
	sys.exit(0)

f = open(inputfile, "r")
lines = f.readlines()
f.close()

w = join(lines," ")
w = w.strip()
for c in phraseSeparators:
	w = replace(w,c,".")
for c in invalidChars:
	w = replace(w,c," ")
while True:
	w = replace(w, "  ", " ")
	if w.find("  ") == -1:
		break
w = split(w,".")
tbc = []
for i in w:
	if len(i.strip()) > 0:
		if MIN_WORDS < len(split(i," ")) < MAX_WORDS:
			tbc.append(i.strip())
candidates = {}
candidates_phrases = {}
n = 0
print len(tbc),"phrases to be considered (from %d to %d words)" % (MIN_WORDS,MAX_WORDS)
for i in tbc:
	n = n + 1
	print ">>> Processing phrase %d of %d:" % (n,len(tbc))
	print i
	terms = replace(i.strip()," ","+")
	result = getoutput("echo \"%s\" | recode latin1..html -q" % (terms))
	resultURLs = getoutput("wget -4 --user-agent=Mozilla -q -O - \"http://www.google.ch/search?hl=it&&hs=HqS&q=%s&btnG=Cerca&meta=\"" % (terms))
	resultURLs = re.findall('<a href="([^>]*)" class=l>(?i)',resultURLs)
	cleanURLs = []
	for k in resultURLs:
		if (k.find("google") < 0) and (k[0:4] == "http") and (k.find("cache") < 0):
			cleanURLs.append(k)
	if len(cleanURLs) > 0:
		print ">>> Found %d source match candidates" % (len(cleanURLs))
		for url in cleanURLs:
			print "   >>>",url
		curmatching = 0
		for c in cleanURLs:
			if candidates.has_key(c):
				count = candidates[c] + 1
				candidates[c] = count
				curmatching += 1
				phrase = candidates_phrases[c]
				phrase.append(i)
				candidates_phrases[c] = phrase
			else:
				candidates[c] = 1
				phrase = [i]
				candidates_phrases[c] = phrase
		print ">>> %d matching with previous candidates" % (curmatching)
	else:
		print ">>> No source candidates found"
	time.sleep(0.2)
items = candidates.items()
itemslist = [[tupl[1],tupl[0]] for tupl in items]
itemslist.sort()
candidates_keys = [itemslist[i][1] for i in range(0,len(itemslist))]
print "\nFound a total of",len(candidates_keys),"matches:"
for z in candidates_keys:
	print candidates[z],"match(es) for source",z,":"
	phrases = candidates_phrases[z]
	for u in phrases:
		print "     >",u
